% connect trajectory over curvature to greater planar brownian diffuser

% with RANGE = 3, D = msd/time_step/4 = 1.135 nm^2/time_step
% if D = 1 um^2/s then time_step = 1.135nm^2/1um^2*s = 1.13 us

% When not near curvature, allow 10 time steps to be taken at a time.
% For Range =3 for dt = 1, this means that the mean step distance is 6.748 when dt = 10;


clear all
clc
addpath('C:\Users\CVKelly\Google Drive\Assorted MATLAB Code\functions')

top_rad = 50;
bot_rad = 20;
density_parameter = 4;
RANGE = 3;

fold_read1 = 'vary_bud_height_50_4\trajectories\';
fold_read2 = 'flat_slb\';
fold_save = 'E_combined_bud_and_slb\';

repeat = 1;

% 1 has bud, 2 is flat
file1 = [fold_read1 'traj_' num2str(height) '_' num2str(top_rad) '_' num2str(bot_rad) '_' num2str(density_parameter) '_' num2str(RANGE) '_' num2str(repeat) '.mat'];
load(file1,'xi','traji','x')
x1 = x(xi,:);
t1 = traji;
file2 = [fold_read2 'flatTraj_' num2str(1.135) '_' num2str(1) '_' num2str(repeat) '.mat'];
load(file1,'traj','traji');
x2 = traj;
t2 = traji;
clear x traj traji xi

x1 = x1(t1<max(t1),:);
x1(end+1,:) = 0;
t1 = t1(t1<max(t1));
t1(end+1) = 0;
x2 = x2(t2<max(t2),:);
x2(end+1,:) = 0;
x2(:,3) = 0;
t2 = t2(t1<max(t1));
t2(end+1) = 0;

r1 = sqrt(x1(:,1).^2+x1(:,2).^2);
r2 = sqrt(x2(:,1).^2+x2(:,2).^2);

maxr1 = max(r1);
transr = maxr1-3;

t = 0;
for tn = unique(t2)  % trajcnt for now (from bigger loop), 1 has bud, 2 has flat.
    if min(r2(t2==ti))>maxr1 % if the trajectory never gets close, that's fine... move along.
        xn = x2(t2==ti,:); % pos (x) now
        xa(t+(1:size(xn,1)),:) = xn(:); % this is the final long list of pos
        ta(t+(1:size(xn,1))) = tn;  %     this is the final long list of trajcnt
    else
        [~,tt] = max(r2(t2==ti))>maxr1; % when does it get close
        xt = x2(t2==ti,:); % get temporary traj
        xn = xt(1:tt,:); % but only save until it's close
        
        [~,~,i] = find_closest_funct(x1,xn(end,:),1); % find the bud to transition to
        xt1 = x1(t1==t1(i),:); % extract only the traj that starts close
        xn(size(xn,1)+(1:size(xt1,1)),:) = xt1;
        
        [~,~,i] = find_closest_funct(x2,xn(end,:),1); % find the flat to transition to

        startt = 1:(length(xi)-1);
        startt = startt(traji(2:end) ~= traji(1:(end-1)));
        trajStart = x(xi(startt),:);

    end
end