% make new trajectories for FRAP
clear all
clc

ddd = 25; % D_bud / D_plane
ttt = 1; % arbitrary repeat number to test consistency, write
tttr = 1; % arbitrary repeat number to test consistency, read
hhh = 100; % height to simulate

sysfold = './';
addpath('./functions')

%% input parameters
Dratio = ddd;
takenum = ttt;

rad = 50;
start_rad = 1000;
num_start_per_step = 10;
plot_rate = 50; % save IvT period
plot_rate2 = plot_rate*20; % plot and save period
max_time = round(0.3/1.125/10^-6/plot_rate2)*plot_rate2;

density = 4;
RANGE = 3;
max_move = RANGE;

for height = hhh
    
    %% randomize 
    tempa=now;
    temp0=rand(takenum*10,1);
    temp1=rand(round(height*10),1);
    temp2=rand(round(Dratio),1);
    pause(abs(tempa-round(tempa)));
    tempb=now;
    tempc=abs(tempb-tempa);
    tempc=tempc*10^-round((log10(tempc)))*10000;
    tempc=tempc-round(tempc);
    tempc=abs(round(tempc*100000));
    temp3=randn(tempc,1);
    disp(['random number seed: ' num2str(tempc)]);
    clear temp0 temp1 temp2 temp3 tempa tempb tempc
    
      
subplot(1,1,1)
hold off
plot(1,1) 
    
%% load data
fold = [sysfold 'vary_bud_height_' num2str(rad) '_' num2str(density) '_100/']; % max rad = 100
load([fold 'topology/MemTopology_' num2str(height) '_' num2str(rad) '_20_' num2str(density) '.mat'],'x'); % loads x for profile of bud
load([fold 'goto_matrices/gotoMatrix_' num2str(height) '_' num2str(rad) '_20_' num2str(density) '_' num2str(max_move) '.mat'],'goto'); % loads goto for diffusion
data_file_read = [sysfold 'newIvT/data_' num2str(Dratio) '_' num2str(height) '_take' num2str(tttr) '.mat']; 
data_file_write = [sysfold 'DLBleach_IvT/data_' num2str(Dratio) '_' num2str(height) '_take' num2str(takenum) '.mat']; 
disp(data_file_write)

load(data_file_read,'trajinow','xnow','num_currentI','num_currentO')

        subplot(2,1,1)
        hold off
        plot3(xnow(1:num_currentO,1),xnow(1:num_currentO,2),xnow(1:num_currentO,1)*0,'.r')
        hold on
        plot3(x(trajinow(1:num_currentI),1),x(trajinow(1:num_currentI),2),x(trajinow(1:num_currentI),3),'.b')
        view([0 90])
        title(num2str([num_currentI num_currentO]))
        xlim([-200 200]); ylim([-200 200])

trajinow(trajinow==0) = 1;
r2nowlist1 = sum(x(trajinow,:).^2,2);
r2nowlist2 = sum(xnow.^2,2);
inow1 = exp(-2*r2nowlist1/250^2);
inow2 = exp(-2*r2nowlist2/250^2);
keep1 = rand(length(inow1),1)>inow1;
keep2 = rand(length(inow2),1)>inow2;

trajinowtemp = trajinow(keep1);
trainow(1:length(trajinowtemp)) = trajinowtemp;
xnowtemp = xnow(keep2,:);
xnow(1:size(xnowtemp,1),:) = xnowtemp;

num_currentI = sum(keep1(1:num_currentI));
num_currentO = sum(keep2(1:num_currentO));

        subplot(2,1,2)
        hold off
        plot3(xnow(1:num_currentO,1),xnow(1:num_currentO,2),xnow(1:num_currentO,1)*0,'.r')
        hold on
        plot3(x(trajinow(1:num_currentI),1),x(trajinow(1:num_currentI),2),x(trajinow(1:num_currentI),3),'.b')
        view([0 90])
        title(num2str([num_currentI num_currentO]))
        xlim([-200 200]); ylim([-200 200])
        drawnow


%% initialize matrices
r = sqrt(x(:,1).^2+x(:,2).^2);
ilist = 1:length(r);
remover = (max(r)-max_move);
remover2 = remover^2;
removeryn = r>remover;
startlist = ilist(r>(max(r)-max_move*1.2) & r<remover);
start_rad2 = start_rad^2;

trajinowt = zeros(10000,1);
outterinner = zeros(10000,1); % 1 = inner
list_moveout = zeros(100,1);
intensity = zeros(round(max_time/plot_rate),1);
col = colormap(jet(max_time/plot_rate));
pcnt = 0;

%% loop over time
for time = 1:max_time
    num_moveout = 0;
    num_movein = 0;
    for i = 1:num_currentI % move all start inner
        if x(trajinow(i),3) == 0 || rand <= 1/Dratio
            pos = goto(trajinow(i),:);
            pos = pos(pos>0 & pos~=i);
            newi = pos(randi(length(pos),1,1));
            if removeryn(newi)
                num_moveout = num_moveout+1;
                num_currentI = num_currentI-1;
                list_moveout(num_moveout) = newi;
            elseif x(trajinow(i),3) == 0 && x(newi,3) ~= 0 && rand > 1/Dratio
                trajinowt(i-num_moveout) = trajinow(i);
            else
                trajinowt(i-num_moveout) = newi;
            end
        else
            trajinowt(i-num_moveout) = trajinow(i);
        end
    end
    num_delete = 0;
    for i = 1:num_currentO % move all start outter
        thstep = rand*2*pi;
        rstep = sqrt(rand)*RANGE;
        xnowt = xnow(i,:)+rstep*[cos(thstep) sin(thstep)];
        r2nowt = sum(xnowt.^2);
        if r2nowt <= remover2
           num_currentI = num_currentI+1;
            num_currentO = num_currentO-1;
            xnowt(3) = 0;
            [~,~,inew] = find_closest_funct(x,xnowt,1);
            trajinowt(num_currentI) = inew;
            num_movein = num_movein+1;
        elseif r2nowt > start_rad2
            num_currentO = num_currentO-1;
            num_delete = num_delete+1;
        else % stay in outer
            xnow(i-num_delete-num_movein,:) = xnowt;
        end
    end
    for i = 1:num_moveout % create locations for moved out
        num_currentO = num_currentO+1;
        xnow(num_currentO,:) = x(list_moveout(i),1:2);
    end
    trajinow(1:num_currentI) = trajinowt(1:num_currentI);
    
    for i = 1:num_start_per_step
        thstep = rand*2*pi;
        num_currentO = num_currentO+1;
        xnow(num_currentO,:) = start_rad*[cos(thstep) sin(thstep)];
    end
    
    if mod(time,plot_rate) == 0
        pcnt = pcnt+1;
        r2nowlist1 = sum(x(trajinow(1:num_currentI),:).^2,2);
        r2nowlist2 = sum(xnow(1:num_currentO,:).^2,2);
        intensity(pcnt) = sum(exp(-2*[r2nowlist1' r2nowlist2']/250^2));
    
    
    if mod(time,plot_rate2) ==0
  
        subplot(3,1,1:2)
        hold off
        plot3(xnow(1:num_currentO,1),xnow(1:num_currentO,2),xnow(1:num_currentO,1)*0,'.r')
        hold on
        plot3(x(trajinow(1:num_currentI),1),x(trajinow(1:num_currentI),2),x(trajinow(1:num_currentI),3),'.b')

        axis equal tight
        xlim([-start_rad start_rad])
        ylim([-start_rad start_rad])
        xlabel('x');ylabel('y');zlabel('z')
        title(num2str([time num_currentO num_currentI]))
        
        subplot(3,1,3)
        hold off
        plot(intensity(1:pcnt))
        xlabel('time')
        ylabel('intensity')
        title(data_file_write,'interpreter','none')
        
    save(data_file_write, ...
        'height','intensity','rad','start_rad','num_start_per_step','max_time','xnow', ...
        'trajinow','plot_rate','RANGE','density','fold','Dratio','num_currentO','num_currentI')
    saveas(gcf,[data_file_write(1:(end-4)) '.jpg'],'jpg')    

    end
    end
end
%% save results
save(data_file_write, ...
    'height','intensity','rad','start_rad','num_start_per_step','max_time','xnow','takenum', ...
    'trajinow','plot_rate','RANGE','density','fold','Dratio','num_currentO','num_currentI');
saveas(gcf,[data_file_write(1:(end-4)) '.jpg'],'jpg');

end
