% do quick scan of data
clear all
clc

fold = 'from grid\DLBleach_IvT\';
hlist = 0:5:140;
Dratio_list = [1 10 25];
take_list = 1:4;

startx = 1;

col = colormap(jet(length(hlist)));

rad = 50;
repeat = 1;
max_move = 3;
density = 4;
ftype = fittype('A*(1-exp(-(x-xz)/x0))');

for Dratio = Dratio_list
for take = take_list
    etxt = ['_take' num2str(take)];
    
    hold off
    hcnt = 0;
    leglist = [];
    Alist = zeros(length(hlist),1);
    eAlist = zeros(length(hlist),1);
    tau = zeros(length(hlist),1);
    etau = zeros(length(hlist),1);
    xnow = etau;

for height = hlist
    hcnt=hcnt+1;
    data_file_read = [fold 'data_' num2str(Dratio) '_' num2str(height) etxt '.mat']; 
    
    try 
        load(data_file_read,'intensity','plot_rate')
       
        intensity = intensity(intensity>0);
        x = 1:length(intensity);
        fres = fit(x(startx:end)',intensity(startx:end),ftype,'start',[100 500 0],'upper',[5*max(intensity) 10^5 100]);
        
        tau(hcnt) = fres.x0;
        Alist(hcnt) = fres.A;
        
        c = confint(fres);
        eAlist(hcnt) = c(2,1)-Alist(hcnt);
        etau(hcnt) = c(2,2)-tau(hcnt);
        xnow(hcnt) = hlist(hcnt);
        
        subplot(1,1,1)
        hold off
        xs = x*plot_rate*1.13*10^-6;
        plot(xs,intensity,'.k')
        hold on
        plot(xs,fres(x),'r-')
        title(data_file_read,'interpreter','none')
        drawnow        
        
    catch
        disp(['failed: ' num2str(height)])
        continue;
    end
end



    subplot(2,1,1)
    hold off
    % plot(Alist,'o-')
    errorbar(hlist,Alist,eAlist,'o-')
    ylabel('A')
    xlim([-2 142])

    subplot(2,1,2)
    hold off
    % plot(tau,'^-')
    errorbar(hlist,tau*plot_rate*1.13*10^-6,etau*plot_rate*1.13*10^-6,'^-')
    ylabel('tau')
    axis tight

    if max(tau) == 0
        disp('canceling')
        return;
    end

    set(gca,'fontsize',15,'linewidth',2)
    xlabel('height')
    title(['last file read: ' data_file_read],'interpreter','none')
    xlim([-2 142])

    saveas(gcf,[fold 'quick fit - Dratio ' num2str(Dratio) etxt '.jpg'],'jpg')
    save([fold 'fit results - Dratio ' num2str(Dratio) etxt '.mat'],'tau','etau','Alist','eAlist','hlist','x','plot_rate')
 
end
end