% compare all fits
clear all
clc
subplot(1,1,1)
hold off
plot(1,1)

fold = 'C:\Users\CVKelly\Google Drive\B - Sensors revisions again\updated simulations\from grid\DLBleach_IvT\';
files = dir([fold 'fit results*take*.mat']);
[m n] = size(files);
col = colormap(lines(3));
sha = 'os^';
for i = 1:m
    f = files(i).name;
    if strfind(f,'10')
        Dratio = 10;
        dcnt = 2;
    elseif strfind(f,'25')
        Dratio = 25;
        dcnt = 3;
    else 
        Dratio = 1;
        dcnt = 1;
    end
    load([fold f])
    
    fprintf([f '\n'])
    subplot(2,1,1)
    errorbar(0:5:140,Alist,eAlist,[sha(dcnt) '-'],'linewidth',2,'color',col(dcnt,:),'markerfacecolor',col(dcnt,:))
    hold on
    subplot(2,1,2)
    errorbar(0:5:140,tau,etau,[sha(dcnt) '-'],'linewidth',2,'color',col(dcnt,:),'markerfacecolor',col(dcnt,:))
    hold on
    
    tau_all(i,:) = tau;
    Alist_all(i,:) = Alist;
    etau_all(i,:) = etau;
    eAlist_all(i,:) = eAlist;
    Dratio_all(i) = Dratio;
end

k = (Alist_all>200) | (tau_all>2500);
tau_all(k) = 0;
etau_all(k) = 0;
Alist_all(k) = 0;
eAlist_all(k) = 0;

ylim([0 max(max(tau_all))])


save([fold 'All fit results.mat'],'tau_all','plot_rate','etau_all','Alist_all','eAlist_all','Dratio_all','hlist')

    