function MSD = Calculate_1D_MSD_funct(XYZ,lag_list)
% input:
%   XYZ results : mx1 matrix
%   max_lag : max number of frame
% calculte MSD vs Dt for dT upto 1/3 of max time
% size(MSD) = [length(dt)/3 2];
%   MSD(:,1) = lag time
%   MSD(:,2) = MSD
%   MSD(:,3) = standard error of mean of SDs

[m n] = size(XYZ);
if m ~= 1 && n ~= 1
    disp('data is wrong size')
    MSD = NaN;
    return;
elseif n ~= 1
    XYZ = XYZ';
end

% dt_list = 1:min([max_lag round(m/3)]);
dt_list = lag_list;
MSD = zeros(length(dt_list),3);

MSD(:,1) = dt_list;
cnt = 0;
for dt = dt_list
    cnt = cnt+1;
    sd = (XYZ((dt+1):end,1) - XYZ(1:(end-dt),1)).^2;
    MSD(cnt,2) = mean(sd);
    MSD(cnt,3) = std(sd)/sqrt(length(sd));
end

