function [x h] = Calculate_1D_StepLengthHist_funct(XYZ,lag_list,bins)
% input:
%   XYZ results : mx1 matrix
%   lag_list : lists of dt values to calculate
%   bins : list of bins to put step lengths into
% calculte MSD vs Dt for dT upto 1/3 of max time
% size(MSD) = [length(dt)/3 2];
%   x(:) = bin centers
%   h(dt,:) = bin heights at each dt

dim = 1; 
[m n] = size(XYZ);
if m ~= dim && n ~= dim
    disp('data is wrong size')
    MSD = NaN;
    return;
elseif n ~= dim
    XYZ = XYZ';
end

% dt_list = 1:min([max_lag round(m/3)]);
dt_list = lag_list;
x = bins+bins(2)/2-bins(1)/2;
h = zeros(length(dt_list),length(bins));

cnt = 0;
for dt = dt_list
    cnt = cnt+1;
    sd = (XYZ((dt+1):end,1) - XYZ(1:(end-dt),1));
    hn = histc(sd,bins);
    h(cnt,:) = hn;
end

