function [x,y,e,msd_all,msd_cnt] = Calculate_MSD_funct(traj)

% calculate initial parameters
parts = length(traj(:,1));
step = traj(2:end,3)-traj(1:(end-1),3);
traj_cnt = max([traj(end,4) length(step(step==1))]);
max_dt = 10;

% initialize arrays
msd_all = zeros(max_dt,traj_cnt);  % delta t, cnt = all step lengths
msd_cnt = zeros(max_dt,1);             % delta t = num combined

% calculate the last trajectory length
last_traj = traj(traj(:,4)==traj(end,4),:);
last_traj_start = parts - length(last_traj(:,1))+1;
traj(end+1,4) = traj(end,4)+1;

% reorganize for distace vs dt
freq_update = floor(last_traj_start/10);
for i = 1:last_traj_start
    if mod(i,freq_update) == 0
        disp(['Calculating MSD. ' num2str(i/parts*100,2) '% completed. ' datestr(now)])
    end
    j = i+1;
    while traj(i,4) == traj(j,4) && j<(i+11)
        dt = j-i;
        msd_cnt(dt) = msd_cnt(dt)+1;
        msd_all(dt,msd_cnt(dt)) = (traj(i,1)-traj(j,1)).^2+(traj(i,2)-traj(j,2)).^2;
        j = j+1;
    end
end        

% calculate Msd
max_dt = length(msd_cnt(msd_cnt>0))-1;
msd_ave = zeros(max_dt,1);
msd_err = zeros(max_dt,1);
for dt = 1:max_dt
    msd_ave(dt) = sum(msd_all(dt,1:msd_cnt(dt)))/msd_cnt(dt);
    msd_err(dt) = std(msd_all(dt,1:msd_cnt(dt)))/sqrt(msd_cnt(dt));
end

x = (1:max_dt);
y = msd_ave;
e = msd_err;

num_plot = min([20 max_dt]);
x = x(1:num_plot);
y = y(1:num_plot);
e = e(1:num_plot);

end
        