function meanr = calc_mean_r_funct(x,y,x0,y0,r0)
% assume a rectangle ROI put into x,y
% x0,y0 are the cetner of the bud
% r0 is a distance from the bud for which all bud-associcated locations are
%     contained within (e.g., much larger than the bud size) but small enough
%     to have sufficient localizations outside radius.

x = x-x0;
y = y-y0;

R = min([max(x) max(y) -min(x) -min(y)]);

xrange = max(x)-min(x);
yrange = max(y)-min(y);

r = sqrt(x.^2+y.^2);
num = sum(r>r0);
area = xrange*yrange-pi*r0^2;
rho = num/area;

x = x(r<=R);
y = y(r<=R);
r = sqrt(x.^2+y.^2);

hold off
plot(x,y,'.')
title('circ')
axis equal tight
pause(1)

nbud = length(x)-rho*pi*R^2;

meanr = sum(r)/nbud-2*pi*rho*R^3/3/nbud;


