function fresult = fit2DGaussRot_funct(data,param)
% analyze and fit images
% data = 2D array of pixel brightness, (might error if not square)
% param = vector of starting parameters for fitting
% param = [amp x_w y_w x0 y0 c ang] 
% fresults will be in terms of pixels and need to be separately converted
% to nm based on the binning details of 'data'

[m n] = size(data);
[X Y] = meshgrid((1:m)-(m/2),(1:n)-(n/2));
% X = (1:m)';
% Y = (1:n)';

x = reshape(X,[],1);
y = reshape(Y,[],1);
z = reshape(data,[],1);

p = param;

%% for laptop
% @(a1, sigmax, sigmay, x0,y0, c, ang, x, y) 
gaussANG = fittype( ... 
    'a1*exp(-(cosd(ang)*(x-x0)-sind(ang)*(y-y0)).^2/(2*sigmax^2)-(sind(ang)*(x-x0)+cosd(ang)*(y-y0)).^2/(2*sigmay^2))+c','independent', {'x', 'y'},'dependent', 'z' );

%% for desktop
% gaussANG = fittype( @(a1, sigmax, sigmay, x0,y0, c, ang, x, y) a1*exp(-(cosd(ang)*(x-x0)-sind(ang)*(y-y0)).^2/(2*sigmax^2)-(sind(ang)*(x-x0)+cosd(ang)*(y-y0)).^2/(2*sigmay^2))+c,'independent', {'x', 'y'},'dependent', 'z' );
fresult = fit([x,y],z,gaussANG,'StartPoint',[p(1) p(2) p(3) p(4) p(5) p(6) p(7)],'lower',[0 -360 -10 0 0 -m/2 -m/2], 'upper',[100 360 10 m/2 m/2 m/2 n/2]);
