function fresult = fit2DGauss_funct(data,param)
% analyze and fit images
% data = 2D array of pixel brightness, (might error if not square)
% param = vector of starting parameters for fitting
% param = [amp x_w y_w x0 y0 c] 
% fresults will be in terms of pixels and need to be separately converted
% to nm based on the binning details of 'data'
%
% ONLY WORKS IN MATLAB >=2014
%

[m n] = size(data);
[X Y] = meshgrid(1:m,1:n);
% X = (1:m)';
% Y = (1:n)';

x = reshape(X,[],1);
y = reshape(Y,[],1);
z = reshape(data,[],1);

p = param;
gauss2 = fittype( @(a1, sigmax, sigmay, x0,y0, c, x, y) a1*exp(-(x-x0).^2/(2*sigmax^2)-(y-y0).^2/(2*sigmay^2))+c,'independent', {'x', 'y'},'dependent', 'z' );
fresult = fit([x,y],z,gauss2,'StartPoint',[p(1) p(2) p(3) p(4) p(5) p(6)],'lower',[0.8 1.7 1.7 0 0 0], 'upper',[1.2 20 20 m n 0.000001]);
