function d_real = fix_D_funct(d_fit,sigma,t_exp,t_frame,n)
% undo the distortion to the fit diffusion coefficient (d_fit) caused by
% the localization uncertainty (sigma), the exposure time (t_exp), the time
% between frames (t_frame), and the number of frames separating the
% locations used (n = Deltat / t_frame).
% d_real = fix_D_funct(d_fit,sigma,t_exp,t_frame,n)
%
% if a single simulation location is used, let t_exp = 0. 

f = t_exp/(n*t_frame);

d_real = (d_fit-sigma.^2/2./n./t_frame)./(1-f/3);
