% Matlab function for frequency domain cross correlation
function [Lag,C]=xcorr_funct(X,Y,L,maxPoints)
% X, Y ---> Input vectors 
% L --->  maximum lag (must be less than minimum of (length of X, Y)
% C ---> correlation vector
% Lag ---> lag times  
X=X(:)-mean(X);
Y=Y(:)-mean(Y);
s1=size(X);
s2=size(Y);
L = round(min([L s1(1,1)/3 s2(1,1)/3]));

X = [zeros(L,1)' X'-mean(X) zeros(1,L)]';
Y = [zeros(1,L) Y'-mean(Y) zeros(L,1)']';

s1=size(X);
s2=size(Y);
D=min(s1(1,1),s2(1,1));

ilist = 10.^(linspace(0,log10(L),maxPoints));
ilist = unique(round(ilist));
cnt = 0;
C = zeros(length(ilist),1);
Lag = zeros(length(ilist),1);
for i=ilist
    X1=ifft(fft(Y(1:D-i)).*conj(fft(X(i+1:D))));
    cnt = cnt+1;
    C(cnt)=X1(1,1);
    Lag(cnt) = i;
end

end